<?php /* -*- PHP -*- */

/* XML header */
Header("content-type: application/xml");

$stat = -1;
$data = "";

/* check for action */
if (array_key_exists ("data", $_POST)) {

    /* create temporary file name */
    $name = tempnam("/tmp", "crg-");
    $logname = $name . ".log";
    $pdfname = $name . ".pdf";
    $texname = $name . ".tex";

    /* create temporary tex file */
    $fd = fopen ($texname, "w");
    if ($fd) {
        fwrite ($fd, $_POST["data"]);
        fclose ($fd);

        /* texify refcard */
        exec ("pdftex -interaction=nonstopmode -output-directory=/tmp " . $texname, $msg, $stat);

        /* read pdf file */
        if (file_exists ($pdfname)) {
            $fd = fopen ($pdfname, "r");
            if ($fd) {
                $data = fread ($fd, filesize ($pdfname));
                fclose ($fd);
            }
        }

        /* clean all files */
        unlink ($name);
        unlink ($texname);
        if (file_exists ($logname)) unlink ($logname);
        if (file_exists ($pdfname)) unlink ($pdfname);
    }
}

/* create XML string */
echo "<xml><message><data><![CDATA[" . base64_encode ($data) . "]]></data><stat>" . $stat . "</stat></message></xml>";